package dev.peerat.mapping.providers.mysql;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import dev.peerat.mapping.providers.Provider;
import dev.peerat.mapping.providers.ProviderManager;
import dev.peerat.parser.java.Class;
import dev.peerat.parser.java.Function;
import dev.peerat.parser.java.Value;
import dev.peerat.parser.java.Value.MethodCallValue;
import dev.peerat.parser.java.operation.ReturnOperation;

public class MySQLProvider implements Provider{
	
	static{
		ProviderManager.getInstance().register("mysql", new MySQLProvider());
	}
	
	private List<String> treasures;
	
	public MySQLProvider(){
		this.treasures = new ArrayList<>();
	}
	
	@Override
	public void init(File file){
		
	}
	

	@Override
	public void mapTreasure(Class clazz){
		treasures.add(clazz.getName().getValue());
	}

	@Override
	public void mapBottle(Class clazz, Function function){
		ReturnOperation operation = (ReturnOperation) function.getElements().get(0);
		Value value = operation.getValue();
		if(value instanceof MethodCallValue){
			MethodCallValue call = (MethodCallValue)value;
			List<MethodCallValue> list = new LinkedList<>();
			while(call.base() instanceof MethodCallValue){
				list.add(0, call);
				call = (MethodCallValue) call.base();
			}
			list.add(0, call);
			MySQLRequestBuilder builder = new MySQLRequestBuilder(list);
			builder.build();
		}
	}

	@Override
	public void mapUses(Class clazz, Function function){
		
	}

}
